package com.hotwj.platform.config.vehicleInspectionConfig.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.vehicleInspectionConfig.domain.HotVehicleInspectionConfig;
import com.hotwj.platform.config.vehicleInspectionConfig.domain.bo.HotVehicleInspectionConfigBo;
import com.hotwj.platform.config.vehicleInspectionConfig.domain.vo.HotVehicleInspectionConfigVo;
import com.hotwj.platform.config.vehicleInspectionConfig.mapper.HotVehicleInspectionConfigMapper;
import com.hotwj.platform.config.vehicleInspectionConfig.service.IHotVehicleInspectionConfigService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 车辆年审检查配置Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotVehicleInspectionConfigServiceImpl implements IHotVehicleInspectionConfigService {

    private final HotVehicleInspectionConfigMapper baseMapper;

    /**
     * 查询车辆年审检查配置
     *
     * @param id 主键
     * @return 车辆年审检查配置
     */
    @Override
    public HotVehicleInspectionConfigVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询车辆年审检查配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 车辆年审检查配置分页列表
     */
    @Override
    public TableDataInfo<HotVehicleInspectionConfigVo> queryPageList(HotVehicleInspectionConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotVehicleInspectionConfig> lqw = buildQueryWrapper(bo);
        Page<HotVehicleInspectionConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的车辆年审检查配置列表
     *
     * @param bo 查询条件
     * @return 车辆年审检查配置列表
     */
    @Override
    public List<HotVehicleInspectionConfigVo> queryList(HotVehicleInspectionConfigBo bo) {
        LambdaQueryWrapper<HotVehicleInspectionConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotVehicleInspectionConfig> buildQueryWrapper(HotVehicleInspectionConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotVehicleInspectionConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotVehicleInspectionConfig::getId);
        lqw.eq(bo.getCompanyId() != null, HotVehicleInspectionConfig::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getIntervalYears() != null, HotVehicleInspectionConfig::getIntervalYears, bo.getIntervalYears());
        lqw.eq(bo.getInspectionTimes() != null, HotVehicleInspectionConfig::getInspectionTimes, bo.getInspectionTimes());
        lqw.eq(bo.getIsDeleted() != null, HotVehicleInspectionConfig::getIsDeleted, bo.getIsDeleted());
        lqw.eq(bo.getIsEnabled() != null, HotVehicleInspectionConfig::getIsEnabled, bo.getIsEnabled());
        return lqw;
    }

    /**
     * 新增车辆年审检查配置
     *
     * @param bo 车辆年审检查配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotVehicleInspectionConfigBo bo) {
        HotVehicleInspectionConfig add = MapstructUtils.convert(bo, HotVehicleInspectionConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改车辆年审检查配置
     *
     * @param bo 车辆年审检查配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotVehicleInspectionConfigBo bo) {
        HotVehicleInspectionConfig update = MapstructUtils.convert(bo, HotVehicleInspectionConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotVehicleInspectionConfig entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除车辆年审检查配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
